Loading...
Searching...
No Matches
juce::OpenGLGraphicsContextCustomShader Struct Reference

## Detailed Description

Used to create custom shaders for use with an openGL 2D rendering context.

Given a GL-based rendering context, you can write a fragment shader that applies some kind of per-pixel effect.

The documentation for this struct was generated from the following file:

- juce_opengl/opengl/juce_OpenGLGraphicsContext.h

## Public Member Functions

| OpenGLGraphicsContextCustomShader (const String &fragmentShaderCode)
| Creates a custom shader.
| ~OpenGLGraphicsContextCustomShader ()
| Destructor.
OpenGLShaderProgram * | getProgram (LowLevelGraphicsContext &) const
| Returns the program, if it has been linked and is active.
void | fillRect (LowLevelGraphicsContext &, Rectangle< int > area) const
| Applies the shader to a rectangle within the graphics context.
Result | checkCompilation (LowLevelGraphicsContext &)
| Attempts to compile the program if necessary, and returns an error message if it fails.
const String & | getFragmentShaderCode () const noexcept
| Returns the code that was used to create this object.

## Public Attributes

std::function< void(OpenGLShaderProgram &)> | onShaderActivated
| Optional lambda that will be called when the shader is activated, to allow user code to do setup tasks.

## Constructors and Destructors

## OpenGLGraphicsContextCustomShader()

juce::OpenGLGraphicsContextCustomShader::OpenGLGraphicsContextCustomShader | ( | const String & | fragmentShaderCode | ) |

Creates a custom shader.

The shader code will not be compiled until actually needed, so it's OK to call this constructor when no GL context is active.

The code should be a normal fragment shader. As well as the usual GLSL variables, there is also an automatically declared varying vec2 called "pixelPos", which indicates the pixel position within the graphics context of the pixel being drawn. There is also a varying value "pixelAlpha", which indicates the alpha by which the pixel should be multiplied, so that the edges of any clip-region masks are anti-aliased correctly.

## ~OpenGLGraphicsContextCustomShader()

juce::OpenGLGraphicsContextCustomShader::~OpenGLGraphicsContextCustomShader | ( |  | ) |

Destructor.

## Member Functions

## getProgram()

OpenGLShaderProgram * juce::OpenGLGraphicsContextCustomShader::getProgram | ( | LowLevelGraphicsContext & |  | ) | const

Returns the program, if it has been linked and is active.

This can be called when you're about to use fillRect, to set up any uniforms/textures that the program may require.

## fillRect()

void juce::OpenGLGraphicsContextCustomShader::fillRect | ( | LowLevelGraphicsContext & | ,
|  | Rectangle< int > | area ) const

Applies the shader to a rectangle within the graphics context.

## checkCompilation()

Result juce::OpenGLGraphicsContextCustomShader::checkCompilation | ( | LowLevelGraphicsContext & |  | ) |

Attempts to compile the program if necessary, and returns an error message if it fails.

## getFragmentShaderCode()

const String & juce::OpenGLGraphicsContextCustomShader::getFragmentShaderCode | ( |  | ) | const

inline noexcept

Returns the code that was used to create this object.

## Member Data Documentation

## onShaderActivated

std::function<void (OpenGLShaderProgram&)> juce::OpenGLGraphicsContextCustomShader::onShaderActivated

Optional lambda that will be called when the shader is activated, to allow user code to do setup tasks.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited